package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmstruckInwardPlanMapper;
import com.steerinfo.dil.model.AmstruckInwardPlan;
import com.steerinfo.dil.model.AmstruckInwardRequirement;
import com.steerinfo.dil.service.IAmstruckInwardPlanService;
import com.steerinfo.dil.service.IAmstruckInwardRequirementService;
import com.steerinfo.dil.service.IAmstruckRequirementPlanService;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * AmstruckInwardPlan服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-25 03:21
 * 类描述
 * 修订历史：
 * 日期：2021-10-25
 * 作者：generator
 * 参考：
 * 描述：AmstruckInwardPlan服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amstruckInwardPlanService")
public class AmstruckInwardPlanServiceImpl extends BaseServiceImpl<AmstruckInwardPlan, BigDecimal> implements IAmstruckInwardPlanService {

    @Autowired
    private AmstruckInwardPlanMapper amstruckInwardPlanMapper;
    @Autowired
    private IAmstruckInwardRequirementService amstruckInwardRequirementService;
    @Autowired
    private IAmstruckRequirementPlanService amstruckRequirementPlanService;
    @Override
    protected IBaseMapper<AmstruckInwardPlan, BigDecimal> getMapper() {
        return amstruckInwardPlanMapper;
    }

    @Override
    public int insert(Map<String,Object> mapValue) {
        BigDecimal requirementId=new BigDecimal(mapValue.get("requirementId").toString());
        //修改需求的状态为已接受
        AmstruckInwardRequirement amstruckInwardRequirement =new AmstruckInwardRequirement();
        amstruckInwardRequirement.setRequirementId(requirementId);
        amstruckInwardRequirement.setRequirementStatus(new BigDecimal(2));
        amstruckInwardRequirement.setUpdateTime(new Date());
        amstruckInwardRequirement.setUpdateUsername("damin");
        amstruckInwardRequirementService.modify(amstruckInwardRequirement);

        BigDecimal planId=amstruckInwardPlanMapper.selectOtherId();
        //在中间表中将需求与计划绑定
        amstruckRequirementPlanService.insert(requirementId,planId);
        AmstruckInwardPlan amstruckInwardPlan=new AmstruckInwardPlan();
        //设置主键
        amstruckInwardPlan.setPlanId(planId);
        //获取承运商id，车数
        BigDecimal carrierId=new BigDecimal(mapValue.get("carrierId").toString());
        BigDecimal planTruckNumber=new BigDecimal(mapValue.get("planTruckNumber").toString());
        amstruckInwardPlan.setCarrierId(carrierId);
        amstruckInwardPlan.setPlanTruckNumber(planTruckNumber);
        DataChange dataChange=new DataChange();
        amstruckInwardPlan.setPlanNumber(dataChange.generateEightDigitsNumber("YSJH",amstruckInwardPlanMapper.selectOtherId().intValue()));
        //设置计划状态为未下发
        amstruckInwardPlan.setPlanStatus(new BigDecimal(0));
        // 设置常规字段
        amstruckInwardPlan.setInsertTime(new Date());
        amstruckInwardPlan.setInsertUsername("admin");
        amstruckInwardPlan.setInsertUpdateRemark("无");
        return amstruckInwardPlanMapper.insertSelective(amstruckInwardPlan);
    }

    @Override
    public List<Map<String, Object>> getTruckPlanList(Map<String, Object> mapValue) {
        return amstruckInwardPlanMapper.getTruckPlanList(mapValue);
    }
}
