package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmstruckInwardRequirementMapper;
import com.steerinfo.dil.model.AmstruckInwardRequirement;
import com.steerinfo.dil.service.IAmstruckInwardRequirementService;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * AmstruckInwardRequirement服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-25 11:30
 * 类描述
 * 修订历史：
 * 日期：2021-10-25
 * 作者：generator
 * 参考：
 * 描述：AmstruckInwardRequirement服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amstruckInwardRequirementService")
public class AmstruckInwardRequirementServiceImpl extends BaseServiceImpl<AmstruckInwardRequirement, BigDecimal> implements IAmstruckInwardRequirementService {

    @Autowired
    private AmstruckInwardRequirementMapper amstruckInwardRequirementMapper;

    @Override
    protected IBaseMapper<AmstruckInwardRequirement, BigDecimal> getMapper() {
        return amstruckInwardRequirementMapper;
    }


    @Override
    public int insert(AmstruckInwardRequirement amstruckInwardRequirement) {
        //设置主键
        amstruckInwardRequirement.setRequirementId(amstruckInwardRequirementMapper.selectOtherId());
        DataChange dataChange=new DataChange();
        amstruckInwardRequirement.setRequirementNumber(dataChange.generateEightDigitsNumber("YSXQ",amstruckInwardRequirementMapper.selectOtherId().intValue()));
        amstruckInwardRequirement.setRequirementStatus(new BigDecimal(0));
        // 设置常规字段
        amstruckInwardRequirement.setInsertTime(new Date());
        amstruckInwardRequirement.setInsertUsername("admin");
        amstruckInwardRequirement.setInsertUpdateRemark("无");
        return amstruckInwardRequirementMapper.insertSelective(amstruckInwardRequirement);
    }

    @Override
    public List<Map<String, Object>> getTruckRequirementList(Map<String, Object> mapValue) {
        return amstruckInwardRequirementMapper.getTruckRequirementList(mapValue);
    }
}
